macro_rules! impl_pnext_in {
    ($implementor: ty, $struct_name: ident) => {
        impl PNextIn<$struct_name> for $implementor {
            fn chain(&mut self, p_next: &$struct_name) {
                unsafe {
                    let self_as_base_structure =
                        self as *mut $implementor as *mut VkBaseInStructure;

                    let last_next = VkBaseInStructure::ptr_chain_iter(self_as_base_structure)
                        .last()
                        .unwrap();

                    (*last_next).pNext = p_next as *const $struct_name as *const _;
                }
            }
        }
    };
}

macro_rules! impl_pnext_out {
    ($implementor: ty, $struct_name: ident) => {
        impl PNextOut<$struct_name> for $implementor {
            fn chain(&mut self, p_next: &mut $struct_name) {
                unsafe {
                    let self_as_base_structure =
                        self as *mut $implementor as *mut VkBaseOutStructure;

                    let last_next = VkBaseOutStructure::ptr_chain_iter(self_as_base_structure)
                        .last()
                        .unwrap();

                    (*last_next).pNext = p_next as *mut $struct_name as *mut _;
                }
            }
        }
    };
}
